extends Node2D

func _ready():
    $Button.connect("pressed", self, "toggle_mode")
    $Area2D.connect("body_entered", self, "body_entered", [], 0) # fails to stop falling object
    #$Area2D.connect("body_entered", self, "body_entered", [], CONNECT_DEFERRED) # succeeds


func body_entered(other : RigidBody2D):
    toggle_mode()


func toggle_mode():
    if $RigidBody2D.mode != RigidBody2D.MODE_RIGID:
        $RigidBody2D.mode = RigidBody2D.MODE_RIGID
        $Label.text = "rigid"
    else:
        $RigidBody2D.mode = RigidBody2D.MODE_STATIC
        $Label.text = "static"
